#define LPT1 				0x3bc
#define LPT2 				0x378
#define LPT3 				0x278

int LPT_ADDR = LPT1;

typedef struct { struct { unsigned dval; float aval; } AD_convtab[20];
								 struct { float low, high; } DA_vrange[8];
}				ADDA_CONVTAB;

enum ADAPTER_TYPES {

//************************************
//****** Pocket ADDIO ****************
//************************************
	PAD10, PAD12,
	PDIO8,
	PDI16,
	PDO16,

//************************************
//****** AD/DA CARDS *****************
//************************************
	AADDA,
	DA8, DA12, DA14,
	ADDA12,
	SADDA12, SADDA14,
	HADDA12, HADDA14, HADDA16,

//************************************
//****** DIGITAL I/O CARDS ***********
//************************************
	_8255, M8255,
	TTL, INDUST8,
	INDUST16
};

enum CHANNEL_NUMBERS {
//******* for A/D D/A ****************
	CHAN0, CHAN1, CHAN2, CHAN3, CHAN4, CHAN5, CHAN6, CHAN7,
	CHAN8, CHAN9, CHAN10,CHAN11,CHAN12,CHAN13,CHAN14,CHAN15,
//********** for DIO *****************
	PORT0, PORT1, PORT2, PORT3, PORT4, PORT5, PORT6, PORT7,
	PORT8, PORT9, PORT10,PORT11,PORT12,PORT13,PORT14,PORT15,
	PORT16,PORT17,PORT18,PORT19,PORT20,PORT21,PORT22,PORT23
};


int  ioinit (int NumberOfAdapters);
//      - allocate & initialize IO buffer
//      - detect CPU speed
//      - returns 1 for successful, 0 for failure
void ioclose (void);
//      - deallocate or free IO buffer
int iosettype (int AdapterType, int BaseAddress, ...);
//      - the optional parameter must be used only for ADDA_CONVTAB
//        w/c is needed by all types of ADDA Adapters
//			- for Pocket ADDIO adapters, BaseAddress represents its BOX ID
//      - returns the assigned AdapterNumber
float ioget (int AdapterNumber, int ChannelNumber);
void  ioset (int AdapterNumber, int ChannelNumber, float data);


