#include "io.h"
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
ADDA_CONVTAB

PAD12_tab = {
							{ {0,0.00},{0xfff,10.00} },
							{ {0,0 }                  }
						},

SADDA14_tab = {
								{ {0,0.00},{0x3fff,10.00}   },
								{ {0.00,10.00},{0.00,10.00} }
							};
int ioaddr;
void RunPhoto(int anum){
			int count = 1;
			clrscr();
			printf("8 Photo 8 Relay Test");
			gotoxy(1,5); printf("PRESS P to Pause, PRESS Q to Quit");
			while(1){
					ioset(anum,PORT0,count);
					gotoxy(1,3); printf("Send Value %4d  Received  Value %4d",count,(int)ioget(anum,PORT1));
					if(count<0x80) count <<=1; else count = 1;
			delay(300);
			if(bioskey(1))
			 switch( toupper(getch()) ){
							case 'Q':  return;
							case 'P': getch();
				 }

		 }
}

void RunPocket12(int anum){
			clrscr();
			printf("12 Bit Pocket A/D Test");
			gotoxy(1,5); printf("PRESS P to Pause, PRESS Q to Quit");
			while(1){
					gotoxy(1,3);
					clreol();
					printf("Received Value  %4.2f",(float)ioget(anum,CHAN0));
					delay(300);
					if(bioskey(1))
			 switch( toupper(getch()) ){
							case 'Q':  return;
							case 'P': getch();
				 }

		 }
}
void RunPocketDIO(int anum){
	int count = 1;
			clrscr();
			printf("8 Bit Pocket DIOTest");
			gotoxy(1,5); printf("PRESS P to Pause, PRESS Q to Quit");
			while(1){
					ioset(anum,PORT0,count);
					gotoxy(1,3); printf("Send Value %4d  Received Value %4d",count,(int)ioget(anum,PORT0));
					if(count<0x80) count <<=1; else count = 1;
			delay(300);
			if(bioskey(1))
			 switch( toupper(getch()) ){
							case 'Q':  return;
							case 'P': getch();
				 }

		 }
}

void RunSuper(int anum){
			float count = 0;
			int chan=0;
			while(1){
					ioset(anum,CHAN0,count);
					gotoxy(1,1);
					clrscr();
					printf("14 Bit Super A/D D/A Test");
					printf("\nSend Value  %4.2f  ",count);
					printf("\n Channel     Received Value");
					for(chan=0;chan<16;chan++)
					printf("\n   %2d             %3.2f",chan,   (float)ioget(anum,chan) );
					printf("\n\nPRESS P to Pause,   PRESS Q to Quit");
					delay(500);
					if ( (count*10) < 100 ) count += 0.5; else count = 0.0;
					if(bioskey(1))
					switch( toupper(getch()) ){
							case 'Q':  return;
							case 'P': getch();
					}
			}
}
int getAddress(void){
		char *saddr;
		return atoi(gets(saddr));
}

char menu(){
	char c;
	clrscr();
	gotoxy(1,1);
	printf("	TEST PROGRAM ");
	printf("\n[0]  8 PHOTO 8 RELAY");
	printf("\n[1]  12 BIT SUPER 14 A/D D/A");
	printf("\n[2]  12 BIT POCKET A/D");
	printf("\n[3]  8 BIT POCKET DIO");
	printf("\n[4]  Exit TEST PROGRAM");
	printf("\n   Select (0..4) ? ");
	do{
		if(bioskey(1)) {
			c = getch();
			if (c >='0' && c <='4') return c;
		}

	}while(1);
	return c;
}

void main(){
			int Photo,Super,Pocket12,PocketDIO;
			do{
				clrscr();
				printf("IO TEST PROGRAM \n\n please wait...");
				ioinit(1);
				switch(menu()){
				 case '0':    clrscr();
											printf("8 Photo 8 Relay");
											printf("\nEnter Address = " );
											ioaddr = getAddress();
											Photo = iosettype(TTL,ioaddr);//0x200);
											RunPhoto(Photo);
											//i/oclose();
											break;
				 case '1':    clrscr();
											printf("14 Bit Super A/D D/A");
											printf("\nEnter Address = " );
											ioaddr = getAddress();
											Super = iosettype(SADDA14, ioaddr, SADDA14_tab); // 0x260
											RunSuper(Super);
											//ioclose();
											break;
				 case '2':    clrscr();
											printf("12 Bit Pocket A/D");
											printf("\nEnter Box ID = " );
											ioaddr = getAddress();
											printf("\nEnter Printer Port");
											printf("\n      [0]  LPT1");
											printf("\n      [1]  LPT2");
											printf("\n      [2]  LPT3");
											printf("\n Select  Print Port [0..2] ? ");
											switch(getch()){
												 case '0' : LPT_ADDR = LPT1;
												 case '1' : LPT_ADDR = LPT2;
												 case '2' : LPT_ADDR = LPT3;
											}
											Pocket12 = iosettype(PAD12,ioaddr,PAD12_tab);
											RunPocket12(Pocket12);
											//ioclose();
											break;
				 case '3':
											clrscr();
											printf("8 Bit Pocket DIO");
											printf("\nEnter Box ID = " );
											ioaddr = getAddress();
											printf("\nEnter Printer Port");
											printf("\n      [0]  LPT1");
											printf("\n      [1]  LPT2");
											printf("\n      [2]  LPT3");
											printf("\n Select  Print Port [0..2] ? ");
											switch(getch()){
												 case '0' : LPT_ADDR = LPT1;
												 case '1' : LPT_ADDR = LPT2;
												 case '2' : LPT_ADDR = LPT3;
											}

											PocketDIO = iosettype(PDIO8,ioaddr);
											RunPocketDIO(PocketDIO);
											//ioclose();
											break;
				 case '4':   	ioclose();
											return;

		 }
		 ioclose();
		}while(1);

}